#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static void initialize_array(int *a, int n);

static void initialize_array(int *a, int n) {
  while (n) {
	*(a++) = n--;
  }
}

void f1(int n) {
  int *a, *b;
  
  if (!(a = malloc(sizeof(int) * n))) {
	return;
  }

  initialize_array(a, n);

  b = a;
  while (n) {
	printf("%d\n", *(a++));
	n--;
  }
  
  free(b);
}

void f2(void) {
  char *a, *b, *c;

  a = "ciao";
  if (!(b = malloc(sizeof(char) * 10))) {
	return;
  }
  strcpy(b, "prova1");
  
  c = b;
  b = a;
  a = c;
  c = NULL;

  printf("a = '%s'\nb = '%s'\n", a, b);

  free(a);
}

int main(int argc, char **argv) {
  f1(10);
  f2();

  return 0;
}
